// @ts-check

const CommandExecutor = require("../CommandExecutor");
const AgentIdentity = require("../../Agent/Identity");

class HBASetup
{
	constructor()
	{}

	/**
	 * @param {AgentIdentity} agentIdentity
	 * @param {Array<Object>} arrServerInterfaces 
	 * @param {Object} objInstance 
	 */
	static async run(agentIdentity, arrServerInterfaces, objInstance)
	{
		let strCommand = "";

		for(let objServerInterface of arrServerInterfaces)
		{
			if(
				objServerInterface["server_interface_add_on_type"] === HBASetup.SERVER_INTERFACE_ADD_ON_HBA
				&& agentIdentity.environment !== AgentIdentity.PRODUCTION
			)
			{
				const strLinedMac = objServerInterface["server_interface_add_on_mac"].replace(/:/g, "-");
	
				strCommand += `
					hbacmd SetInitiatorProperties ${strLinedMac} Initiator_Name="${objInstance["instance_iscsi_initiator_iqn"]}" Auth=1 ${objInstance["instance_iscsi_initiator_username"]} ${objInstance["instance_iscsi_initiator_password_decrypted"]}
					hbacmd SetiSCSIBoot ${strLinedMac} 1
					hbacmd SetNetworkConfiguration  ${strLinedMac} VLAN_Enabled=0 DHCP=1 AA=1
				`;
			}
		}

		const strOutput = CommandExecutor.execCommandProcess(strCommand);

		return strOutput;
	}

	static get SERVER_INTERFACE_ADD_ON_HBA()
	{
		return "hba";
	};
	
}

module.exports = HBASetup;
